# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:report_as) do
  include EasyType

  newvalues(:none, :NONE, :warning, :WARNING, :error, :ERROR, :command, :COMMAND)
  data_type("Optional[Enum['none', 'NONE', 'warning', 'WARNING', 'error', 'ERROR', 'COMMAND', 'command']]")

  desc <<-DESC

  This resource allows you to specify which type of alert(warning or error) you want when the check fails .

      db2_validate { 'validate something':
        ...
        report_as => 'warning|error|command',
        ...
      }

  When you specify `command` as value, a failed check will execute the `fail_command` commands and pass the `fail_message` as
  a message. This can be useful if you want to report validation errors to your monitoring.

  The value of `none` is usefull when using consolidating reporting with the puppet type `validation_reports`

  DESC

  defaultto :warning
end
