# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
module PuppetX
  module EnterpriseModules
    module Db2
      # docs
      module Commands
        def self.included(parent)
          parent.extend(Commands)
        end

        [:db2, :sql, :db2pd].each do |command|
          file  = "puppet_x/enterprisemodules/db2/#{command}_command"
          klass = "#{command.to_s.capitalize}Command"
          require file

          # rubocop: disable Style/DocumentDynamicEvalDefinition
          module_eval(<<-END_RUBY, __FILE__, __LINE__ + 1)
              # @nodoc
              # @private
              def #{command}( arguments, options = {})
                #{command} = PuppetX::EnterpriseModules::Db2::#{klass}.new(options)
                #{command}.execute arguments
              end
          END_RUBY
          # rubocop: enable Style/DocumentDynamicEvalDefinition
        end
      end
    end
  end
end
