# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
#
# Check all requirements for facts
#
# rubocop:disable Style/MixinUsage
def db2_define_fact(fact_name, &block)
  require "#{File.dirname(__FILE__)}/fact"
  include PuppetX::Db2::Fact

  Facter.add("db2_#{fact_name}") do
    confine do
      Puppet.features.db2_running?
    end

    db2_array_fact(:name => 'NAME', :sid => 'SID', &block)
  end
end
# rubocop:enable Style/MixinUsage
