# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#

module PuppetX
  module EnterpriseModules
    module Db2
      # Add documentation TODO
      class InstanceProperty < Puppet::Property
        include PuppetX::EnterpriseModules::Db2::Access

        def apply_value
          automatic = value.to_s.scan(/AUTOMATIC\((.*)\)/).first
          if automatic
            "#{automatic.first} AUTOMATIC"
          else
            value
          end
        end

        def on_apply
          "#{name} #{apply_value}"
        end

        def self.translate_to_resource(raw_resource)
          key = raw_resource.keys.grep(/\(#{name}\)/i).first
          if key.nil? || key.empty?
            Puppet.debug "#{name} property not found in data"
            return nil
          end
          value = raw_resource.column_data(key).strip
          value.empty? ? nil : value
        end
      end
    end
  end
end
