# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
module PuppetX
  module EnterpriseModules
    module Db2
      # Add documentation TODO
      module Property
        def primary?(instance, database)
          resource.class.primary_database_names_on(instance).include?(database)
        end

        def when_primary
          if primary?(resource.instance_name, resource.database_name)
            yield
          else
            Puppet.notice "#{resource.path}: Skipping DB2 query because on database #{resource.database_name} on instance #{resource.instance_name} is running in standby mode."
            nil
          end
        end
      end
    end
  end
end
